/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.plugins.entitybean;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import middlegen.Plugin;
import middlegen.Table;
import middlegen.RelationshipRole;
import middlegen.Util;
import middlegen.javax.JavaTable;
import middlegen.plugins.entitybean.swing.JEntityTableSettingsPanel;
import middlegen.util.BooleanNode;

/**
 * Baseclass for Column decorators. Subclasses can add additional functionality.
 *
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy </a>
 * @created 3. oktober 2001
 * @version $Id: Entity20Table.java,v 1.2 2004/08/23 13:08:56 manu Exp $
 */
public class Entity20Table extends Entity11Table {

   /**
    * @todo-javadoc Describe the column
    */
   private BooleanNode _isLocal;

   /**
    * @todo-javadoc Describe the field
    */
   private String _extentTableName = null;

   //	private Table _extentTable = null;

   /**
    * @todo-javadoc Describe the field
    */
   private Table _subject;

   /**
    * @todo-javadoc Describe the field
    */
   private String _integriteTable;

   /**
    * @todo-javadoc Describe the field
    */
   final static String MAPPING_LOCAL = "Local";

   /**
    * @todo-javadoc Describe the field
    */
   final static String MAPPING_REMOTE = "Remote";

   /**
    * @todo-javadoc Describe the field
    */
   final static String MAPPING_NONE = "none";

   /**
    * @todo-javadoc Describe the field
    */
   final static String MAPPING_UNDEFINED = "undefined";

   /**
    * @todo-javadoc Describe the field
    */
   private static org.apache.log4j.Category _log = org.apache.log4j.Category.getInstance(Entity20Table.class.getName());


   /**
    * Describe what the Entity20Table constructor does
    *
    * @param subject Describe what the parameter does
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   public Entity20Table(Table subject) {
      super(subject);
      this._subject = subject;
   }


   /**
    * @param extentTableName The new ExtentTableName value
    */
   public void setExtentTableName(String extentTableName) {
      setPrefsValue("extends", extentTableName);
      _extentTableName = extentTableName;
      _log.debug("Entity20Table setExtentable : " + _extentTableName);
   }


   /**
    * Describe what the setLocal constructor does
    *
    * @param flag Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   public void setLocal(boolean flag) {
      _isLocal.setValue(flag);
   }


   /**
    * Sets the IntegriteTable attribute of the Entity20Table object
    *
    * @param _integriteTable The new IntegriteTable value
    */
   public void setIntegriteTable(String _integriteTable) {
      setPrefsValue("integrite", _integriteTable);
      this._integriteTable = _integriteTable;
      _log.debug("Entity20Table set_integriteTable : " + _integriteTable);

   }


   /**
    * Gets the ExtentTableName attribute of the Entity20Table object
    *
    * @return The ExtentTableName value
    */
   public String getExtentTableName() {
      if (_extentTableName == null) {
         _extentTableName = getPrefsValue("extends");
         if (_extentTableName == null) {
            _extentTableName = "";
         }
      }
      _log.debug("Entity20Table Name / getExtentable : '" + _extentTableName);
      return _extentTableName;
   }


   /**
    * Gets the ExtentTableSingCapit attribute of the Entity20Table object
    *
    * @return The ExtentTableSingCapit value
    */
   public String getExtentTableSingCapit() {
      _log.debug("Entity20Table getExtentable : " + _extentTableName);
      String s = _extentTableName.toLowerCase();
      s = Util.capitalise(s);
      s = Util.singularise(s);

      return s;
   }


   /**
    * @return Returns the _extentTable.
    */
   public Entity20Table getExtentTable() {
      Table _extentTable = posExtentTable();
      _log.debug("Entity20Table Name / getExtentable : '" + _extentTableName
             + "'/");
      return (Entity20Table)_extentTable;
   }


   /**
    * Gets the LocalClassName attribute of the Entity20Table object
    *
    * @return The LocalClassName value
    */
   public String getLocalClassName() {
      return getQualifiedInterfaceBaseClassName()
             + ((Entity20Plugin)getPlugin()).getLocalsuffix();
   }


   /**
    * Gets the RemoteHomeClassName attribute of the EntityCMPClassType object
    *
    * @return The RemoteHomeClassName value
    * @todo-javadoc Write javadocs for method parameter
    */
   public String getLocalHomeClassName() {
      return getQualifiedInterfaceBaseClassName()
             + ((Entity20Plugin)getPlugin()).getLocalhomesuffix();
   }


   /**
    * Gets the Local attribute of the Entity20Table object
    *
    * @return The Local value
    */
   public BooleanNode getLocal() {
      return _isLocal;
   }


   /**
    * Gets the Local attribute of the Entity20Table object
    *
    * @return The Local value
    */
   public boolean isLocal() {
      return _isLocal.isCompletelyTrue();
   }


   /**
    * Gets the LocalJNDIName attribute of the Entity20Table object
    *
    * @return The LocalJNDIName value
    */
   public String getLocalJNDIName() {
      String result = null;
      Entity20Plugin plugin = (Entity20Plugin)getPlugin();
      if (plugin.getJNDIPrefix() != null) {
         result = plugin.getJNDIPrefix() + "/" + getBaseClassName()
                + plugin.getLocalhomesuffix();
      }
      else {
         result = getLocalHomeClassName().replace('.', '/');
      }
      return result;
   }


   /**
    * Gets the Java signature corresponding to the relationship roles' targets.
    * This method overrides the superclass' method and returns the names of the
    * local interfaces.
    *
    * @param relationshipRoles the roles for which the signature is to be
    *      created
    * @return The RelationSignature value
    */
   public String getRelationSignature(Collection relationshipRoles) {
      StringBuffer sb = new StringBuffer();
      Iterator i = relationshipRoles.iterator();

      while (i.hasNext()) {
         RelationshipRole role = (RelationshipRole)i.next();
         if (!role.isEnabled()) {
            continue;
         }

         Entity20Table target = null;
         Entity20Table origin = null;
         Table t = role.getTarget(getPlugin());
         Table o = role.getOrigin(getPlugin());
         try {
            target = (Entity20Table)t;
            origin = (Entity20Table)o;
         } catch (ClassCastException e) {
            // We don't need a separate check for target and origin; They
            // will always be of same class.
            throw new IllegalStateException(
                  getPlugin().getClass().getName()
                   + " must override getTableDecoratorClass() and return a class which is "
                   + Entity20Table.class.getName()
                   + " (or a subclass). It was "
                   + t.getClass().getName());
         }
         if (sb.length() != 0) {
            sb.append(", ");
         }
         String targetType = target.getLocalClassName();
         String targetName = origin.getVariableName(role);
         sb.append(targetType).append(" ").append(targetName);
      }
      return sb.toString();
   }


   /**
    * Gets the RelationSignatureWithoutPackage attribute of the Entity20Table
    * object
    *
    * @param relationshipRoles Describe what the parameter does
    * @return The RelationSignatureWithoutPackage value
    * @todo-javadoc Write javadocs for method parameter
    */
   public String getRelationSignatureWithoutPackage(
         Collection relationshipRoles) {
      StringBuffer sb = new StringBuffer();
      Iterator i = relationshipRoles.iterator();

      while (i.hasNext()) {
         RelationshipRole role = (RelationshipRole)i.next();
         if (!role.isEnabled()) {
            continue;
         }

         Entity20Table target = null;
         Entity20Table origin = null;
         Table t = role.getTarget(getPlugin());
         Table o = role.getOrigin(getPlugin());
         try {
            target = (Entity20Table)t;
            origin = (Entity20Table)o;
         } catch (ClassCastException e) {
            // We don't need a separate check for target and origin; They
            // will always be of same class.
            throw new IllegalStateException(
                  getPlugin().getClass().getName()
                   + " must override getTableDecoratorClass() and return a class which is "
                   + Entity20Table.class.getName()
                   + " (or a subclass). It was "
                   + t.getClass().getName());
         }
         if (sb.length() != 0) {
            sb.append(", ");
         }
         String targetType = target.getBaseClassName()
                + ((Entity20Plugin)getPlugin()).getLocalsuffix();
         String targetName = origin.getVariableName(role);
         sb.append(targetType).append(" ").append(targetName);
      }
      return sb.toString();
   }


   /**
    * Returns true if none of the set methods are exposed via the remote or
    * local interfaces
    *
    * @return The ReadOnly value
    */
   public boolean isReadOnly() {
      // super tests for remote setters
      boolean readonly = super.isReadOnly();
      boolean allLinks = true;
      if (readonly) {

         // No remote setters. Now check for local ones.
         for (Iterator columns = getColumns().iterator(); columns.hasNext(); ) {
            Entity20Column column = (Entity20Column)columns.next();
            if (!column.isFk()) {
               allLinks = false;
            }
            if (column.isLocalSet()) {
               // It isn't readonly. One column is exposed in a setter in
               // local
               readonly = false;
               break;
            }
         }
      }

      // Can't assume that the bean is read-only if it has only relationships
      // as fields,
      // as local setters for relationships are always generated
      return readonly && !allLinks;
   }


   /**
    * Describe what the method does
    *
    * @return Describe the return value
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for return value
    */
   public String getBeanViewType() {
      boolean isLocal = getLocal().isPartiallyTrue();
      boolean isRemote = getRemote().isPartiallyTrue();
      return Entity20Column.viewType(isLocal, isRemote);
   }


   /**
    * @return the result type mapping for the finders
    */
   public String getResultTypeMapping() {
      boolean isLocal = getLocal().isPartiallyTrue();
      boolean isRemote = getRemote().isPartiallyTrue();
      if (isRemote) {
         if (isLocal) {
            return MAPPING_NONE;
         }
         else {
            return MAPPING_REMOTE;
         }
      }
      else if (isLocal) {
         return MAPPING_LOCAL;
      }
      return MAPPING_UNDEFINED;
   }


   /**
    * Gets the OneClassName attribute of the Entity20Table object
    *
    * @return The OneClassName value
    */
   public String getQualifiedDestinationClassName() {
      return getLocalClassName();
   }


   /**
    * Gets the FinderNameForUniqueTuple attribute of the Entity20Table object
    *
    * @param uniqueTuple Describe what the parameter does
    * @return The FinderNameForUniqueTuple value
    */
   public String getFinderNameFor(Collection uniqueTuple) {
      StringBuffer sb = new StringBuffer("findBy");
      for (Iterator i = uniqueTuple.iterator(); i.hasNext(); ) {
         Object o = i.next();
         Entity20Column c = (Entity20Column)o;
         sb.append(c.getCapitalisedVariableName());
      }
      return sb.toString();
   }


   /**
    * Gets the FinderSignatureForUniqueTuple attribute of the Entity20Table
    * object
    *
    * @param uniqueTuple Describe what the parameter does
    * @return The FinderSignatureForUniqueTuple value
    */
   public String getFinderSignatureFor(Collection uniqueTuple) {
      StringBuffer sb = new StringBuffer();
      for (Iterator i = uniqueTuple.iterator(); i.hasNext(); ) {
         Entity20Column c = (Entity20Column)i.next();
         sb.append(c.getJavaType()).append(" ").append(c.getVariableName());
         if (i.hasNext()) {
            sb.append(", ");
         }
      }
      return sb.toString();
   }


   /**
    * Gets the FinderQueryForUniqueTuple attribute of the Entity20Table object
    *
    * @param uniqueTuple Describe what the parameter does
    * @return The FinderQueryForUniqueTuple value
    */
   public String getFinderQueryFor(Collection uniqueTuple) {
      StringBuffer sb = new StringBuffer("SELECT DISTINCT OBJECT(o) FROM "
             + getBeanName() + " o WHERE ");
      int index = 1;
      for (Iterator i = uniqueTuple.iterator(); i.hasNext(); index++) {
         Entity20Column c = (Entity20Column)i.next();
         sb.append("o." + c.getVariableName() + " = ?" + index + " ");
         if (i.hasNext()) {
            sb.append("AND ");
         }
      }
      return sb.toString();
   }


   /**
    * Gets the LocalClassPackage attribute of the Entity20Table object
    *
    * @return The LocalClassName value
    */
   public String getLocalClassPackage() {
      return getInterfacePackage();
   }


   /**
    * Gets the Plugin attribute of the Entity20Table object
    *
    * @return The Plugin value
    */
   public Plugin getPlugin() {
      return super.getPlugin();
   }


   /**
    * Gets the ConstructorVO attribute of the Entity20Table object
    *
    * @return The ConstructorVO value
    */
   public String getConstructorVO() {
      StringBuffer sb = new StringBuffer();

      for (Iterator columns = getColumns().iterator(); columns.hasNext(); ) {
         Entity20Column column = (Entity20Column)columns.next();
         if (!column.isCtor()) {
            continue;
         }
         if (sb.length() != 0) {
            sb.append(", ");
         }
         sb.append(column.getJavaType());
         sb.append(" ");
         sb.append(column.getVariableName());
      }

      return sb.toString();
   }


   /**
    * Gets the IntegriteTable attribute of the Entity20Table object
    *
    * @return The IntegriteTable value
    */
   public String getIntegriteTable() {
      if (_integriteTable == null) {
         _integriteTable = getPrefsValue("integrite");
         if (_integriteTable == null) {
            _integriteTable = "";
         }
      }
      _log.debug("Entity20Table Name / getintegriteTable : '"
             + _integriteTable);

      return _integriteTable;
   }


   /**
    * Describe what the method does
    *
    * @todo-javadoc Write javadocs for method
    */
   protected void init() {
      _log.debug(" init table : " + getName());

      super.init();
      Entity20Plugin plugin = (Entity20Plugin)getPlugin();
      _isLocal = plugin.getLocal().createChild(false);

      _extentTableName = getPrefsValue("extend-table-name");
      _log.debug(" table : " + getName() + " extend-table-name : "
             + _extentTableName);
   }


   /**
    * Describe what the method does
    *
    * @return Describe the return value
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for return value
    */
   private Entity20Table posExtentTable() {

      // rechercher dans les realtions la table associe
      Iterator it = getRelationshipRoles().iterator();
      RelationshipRole role = null;
      while (it.hasNext()) {
         role = (RelationshipRole)it.next();

         if (role.isTargetMany()) {
            continue;
         }

         if (!role.getTarget().getName().equalsIgnoreCase(
               getExtentTableName())) {
            continue;
         }

         Table t = role.getTarget(getPlugin());

         //			Entity20Table en20 = (Entity20Table) t;
         //			_log.debug(" package" + en20.getPackage());

         return (Entity20Table)t;
      }
      return null;
   }
}

