/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.plugins.entitybean;

/**
 * Settings for Oracle Sequence Accessor
 *
 * @author <a href="mailto:mflor@users.sourceforge.net">Matthias Flor</a>
 * @created 2. december 2002
 */
public class OracleSequence {
   /**
    * @todo-javadoc Describe the field
    */
   private Entity11Plugin _plugin;

   /**
    * @todo-javadoc Describe the field
    */
   private String _package = null;
   /**
    * @todo-javadoc Describe the field
    */
   private String _interfacePackage = null;

   /**
    * The datasource for the OracleSequenceSessionBean
    */
   private String _datasource = "java:/OracleDS";


   /**
    * Sets the Package attribute of the SequenceBlock object
    *
    * @param s The new Package value
    */
   public void setPackage(String s) {
      _package = s;
   }


   /**
    * Sets the Package attribute of the SequenceBlock object
    *
    * @param s The new Package value
    */
   public void setInterfacepackage(String s) {
      _interfacePackage = s;
   }


   /**
    * Sets the Table attribute of the SequenceBlock object
    *
    * @param s The new Table value
    */
   public void setDatasource(String s) {
      _datasource = s;
   }


   /**
    * Gets the InterfacePackage attribute of the SequenceBlock object. If this
    * attribute is not set the 'interfacepackage' attribute of the plugin will
    * be returned.
    *
    * @return The InterfacePackage value
    */
   public String getInterfacePackage() {
      return _interfacePackage != null ? _interfacePackage : _plugin.getInterfacePackage();
   }


   /**
    * Gets the Package attribute of the OracleSequence object. If this attribute
    * is not set the 'package' attribute of the plugin will be returned.
    *
    * @return The Package value
    */
   public String getPackage() {
      return _package != null ? _package : _plugin.getPackage();
   }


   /**
    * Gets the datasource attribute of the OracleSequence object
    *
    * @return The Datasource value
    */
   public String getDatasource() {
      return _datasource;
   }


   /**
    * Sets the Plugin attribute of the SequenceBlock object
    *
    * @param plugin The new Plugin value
    */
   void setPlugin(Entity11Plugin plugin) {
      _plugin = plugin;
   }

}
