/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.plugins.entitybean;

/**
 * Settings for Sequence Block PK generator
 *
 * @author Aslak Hellesy
 * @created 4. september 2002
 */
public class SequenceBlock {
   /**
    * @todo-javadoc Describe the field
    */
   private Entity11Plugin _plugin;

   /**
    * @todo-javadoc Describe the field
    */
   private int _blockSize = 10;
   /**
    * @todo-javadoc Describe the field
    */
   private int _retryCount = 3;
   /**
    * @todo-javadoc Describe the field
    */
   private String _package = null;
   /**
    * @todo-javadoc Describe the field
    */
   private String _interfacePackage = null;
   /**
    * @todo-javadoc Describe the field
    */
   private String _table = "sequence_block";

   /**
    * The schema this table belongs to.
    */
   private String _schemaName = null;


   /**
    * Sets the Blocksize attribute of the SequenceBlock object
    *
    * @param i The new Blocksize value
    */
   public void setBlocksize(int i) {
      _blockSize = i;
   }


   /**
    * Sets the Retrycount attribute of the SequenceBlock object
    *
    * @param i The new Retrycount value
    */
   public void setRetrycount(int i) {
      _retryCount = i;
   }


   /**
    * Sets the Package attribute of the SequenceBlock object
    *
    * @param s The new Package value
    */
   public void setPackage(String s) {
      _package = s;
   }


   /**
    * Sets the Package attribute of the SequenceBlock object
    *
    * @param s The new Package value
    */
   public void setInterfacepackage(String s) {
      _interfacePackage = s;
   }


   /**
    * Sets the Table attribute of the SequenceBlock object
    *
    * @param s The new Table value
    */
   public void setTable(String s) {
      _table = s;
   }


   /**
    * Sets the Schema attribute of the SequenceBlock object
    *
    * @param schemaName The new Schema value
    */
   public void setSchema(String schemaName) {
      _schemaName = schemaName;
   }


   /**
    * Gets the InterfacePackage attribute of the SequenceBlock object
    *
    * @return The InterfacePackage value
    */
   public String getInterfacePackage() {
      return _interfacePackage != null ? _interfacePackage : _plugin.getInterfacePackage();
   }


   /**
    * Gets the Blocksize attribute of the SequenceBlock object
    *
    * @return The Blocksize value
    */
   public int getBlocksize() {
      return _blockSize;
   }


   /**
    * Gets the Retrycount attribute of the SequenceBlock object
    *
    * @return The Retrycount value
    */
   public int getRetrycount() {
      return _retryCount;
   }


   /**
    * Gets the Table attribute of the SequenceBlock object
    *
    * @return The Table value
    */
   public String getTable() {
      boolean noschema = _schemaName == null || _schemaName.trim().equals("");
      String result;
      if (noschema) {
         result = _table;
      }
      else {
         result = _schemaName + "." + _table;
      }
      return result;
   }


   /**
    * Gets the Package attribute of the SequenceBlock object
    *
    * @return The Package value
    */
   public String getPackage() {
      return _package != null ? _package : _plugin.getPackage();
   }


   /**
    * Sets the Plugin attribute of the SequenceBlock object
    *
    * @param plugin The new Plugin value
    */
   void setPlugin(Entity11Plugin plugin) {
      _plugin = plugin;
   }
}
