/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.swing;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.border.BevelBorder;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import middlegen.Table;

/**
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy </a>
 * @created 3. oktober 2001
 * @version $Id: JTableList.java,v 1.1 2004/08/20 06:53:31 manu Exp $
 */
public class JTableList extends JList {

   /**
    * @todo-javadoc Describe the column
    */
   private final Table _table;

   /**
    * @todo-javadoc Describe the field
    */
   private JPopupMenu popup;

   /**
    * @todo-javadoc Describe the column
    */
   private static ColumnListCellRenderer _renderer = new ColumnListCellRenderer();

   /**
    * Get static reference to Log4J Logger
    */
   private static org.apache.log4j.Category _log = org.apache.log4j.Category.getInstance(JTableList.class.getName());


   /**
    * Creates new JTableList
    *
    * @param table Describe what the parameter does
    * @todo-javadoc Write javadocs for method parameter
    * @pre table != null
    */
   public JTableList(Table table) {
      super(new TableListModel(table));

      _log.debug("entering JTableList ...");

      setCellRenderer(_renderer);
      _table = table;
//		popup = new JPopupMenu();
//		ActionListener menuListener = new ActionListener() {
//			public void actionPerformed(ActionEvent event) {
//				System.out.println("Popup menu item ["
//						+ event.getActionCommand() + "] was pressed.");
//			}
//		};
//		JMenuItem item;
//		popup.add(item = new JMenuItem("Left", new ImageIcon("left.gif")));
//		item.setHorizontalTextPosition(JMenuItem.RIGHT);
//		item.addActionListener(menuListener);
//		popup.add(item = new JMenuItem("Center", new ImageIcon("center.gif")));
//		item.setHorizontalTextPosition(JMenuItem.RIGHT);
//		item.addActionListener(menuListener);
//		popup.add(item = new JMenuItem("Right", new ImageIcon("right.gif")));
//		item.setHorizontalTextPosition(JMenuItem.RIGHT);
//		item.addActionListener(menuListener);
//		popup.add(item = new JMenuItem("Full", new ImageIcon("full.gif")));
//		item.setHorizontalTextPosition(JMenuItem.RIGHT);
//		item.addActionListener(menuListener);
//		popup.addSeparator();
//		popup.add(item = new JMenuItem("Settings . . ."));
//		item.addActionListener(menuListener);
//
//		popup.setLabel("Justification");
//		popup.setBorder(new BevelBorder(BevelBorder.RAISED));
//		popup.addPopupMenuListener(new PopupPrintListener());

   }


   /**
    * Gets the Table attribute of the JTableList object
    *
    * @return The Table value
    */
   public Table getTable() {
      return _table;
   }


   // An inner class to check whether mouse events are the pop-up trigger
   /**
    * Describe what this class does
    *
    * @author Cnedi
    * @created 20 aot 2004
    * @todo-javadoc Write javadocs
    */
   class MousePopupListener extends MouseAdapter {

      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void mousePressed(MouseEvent e) {
         checkPopup(e);
      }


      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void mouseClicked(MouseEvent e) {
         checkPopup(e);
      }


      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void mouseReleased(MouseEvent e) {
         checkPopup(e);
      }


      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      private void checkPopup(MouseEvent e) {
         if (e.isPopupTrigger()) {
            popup.show(JTableList.this, e.getX(), e.getY());
         }
      }
   }


   // An inner class to show when pop-up events occur
   /**
    * Describe what this class does
    *
    * @author Cnedi
    * @created 20 aot 2004
    * @todo-javadoc Write javadocs
    */
   class PopupPrintListener implements PopupMenuListener {
      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
         System.out.println("Popup menu will be visible!");
      }


      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
         System.out.println("Popup menu will be invisible!");
      }


      /**
       * Describe what the method does
       *
       * @param e Describe what the parameter does
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for method parameter
       */
      public void popupMenuCanceled(PopupMenuEvent e) {
         System.out.println("Popup menu is hidden!");
      }
   }

}

